import { Chrome } from './Chrome';
import { options as chromeOptions } from './util/ChromeHelper';
export interface constructorOpts {
    numInstances?: number;
    maxJobs?: number;
    workerTTL?: number;
    chromeOptions?: chromeOptions;
}
export interface jobFunc {
    (chromeTab: Chrome): Promise<any>;
}
export declare class Navalia {
    private chromeInstances;
    private queueList;
    private numInstances;
    private maxJobs;
    private workerTTL;
    private chromeOptions;
    constructor(opts?: constructorOpts);
    private destroy(chrome);
    private execute(chromeHelper, queueItem);
    private launchInstance(chromeOptions);
    kill(): Promise<void[]>;
    run(handler: jobFunc): Promise<any>;
}
